Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # test of qemu-img convert -n - convert without creation |
| 4 | # |
| 5 | # Copyright (C) 2009 Red Hat, Inc. |
| 6 | # Copyright (C) 2013 Alex Bligh (alex@alex.org.uk) |
| 7 | # |
| 8 | # This program is free software; you can redistribute it and/or modify |
| 9 | # it under the terms of the GNU General Public License as published by |
| 10 | # the Free Software Foundation; either version 2 of the License, or |
| 11 | # (at your option) any later version. |
| 12 | # |
| 13 | # This program is distributed in the hope that it will be useful, |
| 14 | # but WITHOUT ANY WARRANTY; without even the implied warranty of |
| 15 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| 16 | # GNU General Public License for more details. |
| 17 | # |
| 18 | # You should have received a copy of the GNU General Public License |
| 19 | # along with this program. If not, see <http://www.gnu.org/licenses/>. |
| 20 | # |
| 21 | |
| 22 | # creator |
| 23 | owner=alex@alex.org.uk |
| 24 | |
| 25 | seq=`basename $0` |
| 26 | echo "QA output created by $seq" |
| 27 | |
| 28 | here=`pwd` |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 29 | status=1 # failure is the default! |
| 30 | |
| 31 | _cleanup() |
| 32 | { |
| 33 | _cleanup_test_img |
Kevin Wolf | 1803f3f | 2017-07-27 15:13:20 +0200 | [diff] [blame] | 34 | rm -f "$TEST_IMG.orig" "$TEST_IMG.raw1" "$TEST_IMG.raw2" |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 35 | } |
| 36 | trap "_cleanup; exit \$status" 0 1 2 3 15 |
| 37 | |
| 38 | # get standard environment, filters and checks |
| 39 | . ./common.rc |
| 40 | . ./common.filter |
| 41 | . ./common.pattern |
| 42 | |
| 43 | _supported_fmt qcow qcow2 vmdk qed raw |
Peter Lieven | 1f7bf7d | 2014-02-03 10:26:14 +0100 | [diff] [blame] | 44 | _supported_proto file |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 45 | _supported_os Linux |
Fam Zheng | d2329f2 | 2013-11-26 14:40:33 +0800 | [diff] [blame] | 46 | _unsupported_imgopts "subformat=monolithicFlat" \ |
| 47 | "subformat=twoGbMaxExtentFlat" \ |
| 48 | "subformat=twoGbMaxExtentSparse" |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 49 | |
| 50 | _make_test_img 4M |
| 51 | |
| 52 | echo "== Testing conversion with -n fails with no target file ==" |
| 53 | # check .orig file does not exist |
Jeff Cody | fef9c19 | 2013-09-25 08:12:22 -0400 | [diff] [blame] | 54 | rm -f "$TEST_IMG.orig" |
| 55 | if $QEMU_IMG convert -f $IMGFMT -O $IMGFMT -n "$TEST_IMG" "$TEST_IMG.orig" >/dev/null 2>&1; then |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 56 | exit 1 |
| 57 | fi |
| 58 | |
| 59 | echo "== Testing conversion with -n succeeds with a target file ==" |
Jeff Cody | fef9c19 | 2013-09-25 08:12:22 -0400 | [diff] [blame] | 60 | rm -f "$TEST_IMG.orig" |
| 61 | cp "$TEST_IMG" "$TEST_IMG.orig" |
| 62 | if ! $QEMU_IMG convert -f $IMGFMT -O $IMGFMT -n "$TEST_IMG" "$TEST_IMG.orig" ; then |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 63 | exit 1 |
| 64 | fi |
| 65 | |
| 66 | echo "== Testing conversion to raw is the same after conversion with -n ==" |
| 67 | # compare the raw files |
Jeff Cody | fef9c19 | 2013-09-25 08:12:22 -0400 | [diff] [blame] | 68 | if ! $QEMU_IMG convert -f $IMGFMT -O raw "$TEST_IMG" "$TEST_IMG.raw1" ; then |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 69 | exit 1 |
| 70 | fi |
| 71 | |
Jeff Cody | fef9c19 | 2013-09-25 08:12:22 -0400 | [diff] [blame] | 72 | if ! $QEMU_IMG convert -f $IMGFMT -O raw "$TEST_IMG.orig" "$TEST_IMG.raw2" ; then |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 73 | exit 1 |
| 74 | fi |
| 75 | |
Jeff Cody | fef9c19 | 2013-09-25 08:12:22 -0400 | [diff] [blame] | 76 | if ! cmp "$TEST_IMG.raw1" "$TEST_IMG.raw2" ; then |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 77 | exit 1 |
| 78 | fi |
| 79 | |
| 80 | echo "== Testing conversion back to original format ==" |
Jeff Cody | fef9c19 | 2013-09-25 08:12:22 -0400 | [diff] [blame] | 81 | if ! $QEMU_IMG convert -f raw -O $IMGFMT -n "$TEST_IMG.raw2" "$TEST_IMG" ; then |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 82 | exit 1 |
| 83 | fi |
| 84 | _check_test_img |
| 85 | |
| 86 | echo "== Testing conversion to a smaller file fails ==" |
Jeff Cody | fef9c19 | 2013-09-25 08:12:22 -0400 | [diff] [blame] | 87 | rm -f "$TEST_IMG.orig" |
| 88 | mv "$TEST_IMG" "$TEST_IMG.orig" |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 89 | _make_test_img 2M |
Jeff Cody | fef9c19 | 2013-09-25 08:12:22 -0400 | [diff] [blame] | 90 | if $QEMU_IMG convert -f $IMGFMT -O $IMGFMT -n "$TEST_IMG.orig" "$TEST_IMG" >/dev/null 2>&1; then |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 91 | exit 1 |
| 92 | fi |
| 93 | |
Alexandre Derumier | b2e1049 | 2013-09-02 19:07:24 +0100 | [diff] [blame] | 94 | echo "*** done" |
| 95 | rm -f $seq.full |
| 96 | status=0 |
| 97 | exit 0 |